/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.192 Revision 1.384
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.192 2005/07/15 22:16:49 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.384 2012/02/26 13:20:59 pacho Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12inherit multilib 5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
13 17
14DEPEND="!bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
15# sys-apps/shadow is needed for useradd, etc, bug #94745. 19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
21inherit multilib portability user
16 22
17DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
18 24
19# Wait for the supplied number of seconds. If no argument is supplied, defaults 25if has "${EAPI:-0}" 0 1 2; then
20# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 26
21# outputting to a terminal, don't wait. For compatability purposes, the argument 27# @FUNCTION: epause
22# must be an integer greater than zero. 28# @USAGE: [seconds]
23# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 29# @DESCRIPTION:
30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
31# printing a message the user should probably be reading and often used in
32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
33# don't wait at all. Defined in EAPIs 0 1 and 2.
24epause() { 34epause() {
25 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
26 sleep ${1:-5}
27 fi
28} 36}
29 37
30# Beep the specified number of times (defaults to five). If our output 38# @FUNCTION: ebeep
31# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 39# @USAGE: [number of beeps]
32# don't beep. 40# @DESCRIPTION:
33# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 41# Issue the specified number of beeps (default of 5 beeps). Useful when
42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
34ebeep() { 45ebeep() {
35 local n 46 local n
36 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
37 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
38 echo -ne "\a" 49 echo -ne "\a"
39 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 50 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
40 echo -ne "\a" 51 echo -ne "\a"
41 sleep 1 52 sleep 1
42 done 53 done
43 fi 54 fi
44} 55}
45 56
46# This function generate linker scripts in /usr/lib for dynamic 57else
47# libs in /lib. This is to fix linking problems when you have
48# the .so in /lib, and the .a in /usr/lib. What happens is that
49# in some cases when linking dynamic, the .a in /usr/lib is used
50# instead of the .so in /lib due to gcc/libtool tweaking ld's
51# library search path. This cause many builds to fail.
52# See bug #4411 for more info.
53#
54# To use, simply call:
55#
56# gen_usr_ldscript libfoo.so
57#
58# Note that you should in general use the unversioned name of
59# the library, as ldconfig should usually update it correctly
60# to point to the latest version of the library present.
61#
62# <azarah@gentoo.org> (26 Oct 2002)
63#
64gen_usr_ldscript() {
65 local libdir="$(get_libdir)"
66 # Just make sure it exists
67 dodir /usr/${libdir}
68 58
69 for lib in "${@}" ; do 59ebeep() {
70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
71 /* GNU ld script 61}
72 Since Gentoo has critical dynamic libraries
73 in /lib, and the static versions in /usr/lib,
74 we need to have a "fake" dynamic lib in /usr/lib,
75 otherwise we run into linking problems.
76 62
77 See bug http://bugs.gentoo.org/4411 for more info. 63epause() {
78 */ 64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
79 GROUP ( /${libdir}/${lib} ) 65}
80 END_LDSCRIPT 66
81 fperms a+x "/usr/${libdir}/${lib}" 67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
82# @FUNCTION: ecvs_clean
83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
82 done 115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
83} 121}
84 122
85# Simple function to draw a line consisting of '=' the same length as $* 123# @FUNCTION: estack_pop
86# - only to be used by epatch() 124# @USAGE: <stack> [variable]
87# 125# @DESCRIPTION:
88# <azarah@gentoo.org> (11 Nov 2002) 126# Pop a single item off the specified stack. If a variable is specified,
89# 127# the popped item is stored there. If no more items are available, return
90draw_line() { 128# 1, else return 0. See estack_push for more info.
91 local i=0 129estack_pop() {
92 local str_length="" 130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
93 131
94 # Handle calls that do not have args, or wc not being installed ... 132 # We use the fugly __estack_xxx var names to avoid collision with
95 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ] 133 # passing back the return value. If we used "local i" and the
96 then 134 # caller ran `estack_pop ... i`, we'd end up setting the local
97 echo "===============================================================" 135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
147 fi
148 eval unset ${__estack_name}\[${__estack_i}\]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -s noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
98 return 0 169# return 0
99 fi 170# fi
100
101 # Get the length of $*
102 str_length="$(echo -n "$*" | wc -m)"
103
104 while [ "$i" -lt "${str_length}" ]
105 do
106 echo -n "="
107
108 i=$((i + 1))
109 done 171# done
110 172# eshopts_pop
111 echo 173# @CODE
112 174eshopts_push() {
113 return 0 175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
114} 184}
115 185
116# Default directory where patches are located 186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
218 local s
219 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
220 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
221}
222
223# @VARIABLE: EPATCH_SOURCE
224# @DESCRIPTION:
225# Default directory to search for patches.
117EPATCH_SOURCE="${WORKDIR}/patch" 226EPATCH_SOURCE="${WORKDIR}/patch"
118# Default extension for patches 227# @VARIABLE: EPATCH_SUFFIX
228# @DESCRIPTION:
229# Default extension for patches (do not prefix the period yourself).
119EPATCH_SUFFIX="patch.bz2" 230EPATCH_SUFFIX="patch.bz2"
231# @VARIABLE: EPATCH_OPTS
232# @DESCRIPTION:
120# Default options for patch 233# Default options for patch:
234# @CODE
121# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 235# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
122# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 236# --no-backup-if-mismatch - do not leave .orig files behind
237# -E - automatically remove empty files
238# @CODE
123EPATCH_OPTS="-g0 --no-backup-if-mismatch" 239EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
240# @VARIABLE: EPATCH_EXCLUDE
241# @DESCRIPTION:
124# List of patches not to apply. Not this is only file names, 242# List of patches not to apply. Note this is only file names,
125# and not the full path .. 243# and not the full path. Globs accepted.
126EPATCH_EXCLUDE="" 244EPATCH_EXCLUDE=""
245# @VARIABLE: EPATCH_SINGLE_MSG
246# @DESCRIPTION:
127# Change the printed message for a single patch. 247# Change the printed message for a single patch.
128EPATCH_SINGLE_MSG="" 248EPATCH_SINGLE_MSG=""
249# @VARIABLE: EPATCH_MULTI_MSG
250# @DESCRIPTION:
129# Change the printed message for multiple patches. 251# Change the printed message for multiple patches.
130EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 252EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
131# Force applying bulk patches even if not following the style: 253# @VARIABLE: EPATCH_FORCE
132# 254# @DESCRIPTION:
133# ??_${ARCH}_foo.${EPATCH_SUFFIX} 255# Only require patches to match EPATCH_SUFFIX rather than the extended
134# 256# arch naming style.
135EPATCH_FORCE="no" 257EPATCH_FORCE="no"
136 258
137# This function is for bulk patching, or in theory for just one 259# @FUNCTION: epatch
138# or two patches. 260# @USAGE: [patches] [dirs of patches]
261# @DESCRIPTION:
262# epatch is designed to greatly simplify the application of patches. It can
263# process patch files directly, or directories of patches. The patches may be
264# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
265# the -p option as epatch will automatically attempt -p0 to -p5 until things
266# apply successfully.
139# 267#
140# It should work with .bz2, .gz, .zip and plain text patches. 268# If you do not specify any options, then epatch will default to the directory
141# Currently all patches should be the same format. 269# specified by EPATCH_SOURCE.
142# 270#
143# You do not have to specify '-p' option to patch, as it will 271# When processing directories, epatch will apply all patches that match:
144# try with -p0 to -p5 until it succeed, or fail at -p5. 272# @CODE
145# 273# if ${EPATCH_FORCE} != "yes"
146# Above EPATCH_* variables can be used to control various defaults,
147# bug they should be left as is to ensure an ebuild can rely on
148# them for.
149#
150# Patches are applied in current directory.
151#
152# Bulk Patches should preferibly have the form of:
153#
154# ??_${ARCH}_foo.${EPATCH_SUFFIX} 274# ??_${ARCH}_foo.${EPATCH_SUFFIX}
275# else
276# *.${EPATCH_SUFFIX}
277# @CODE
278# The leading ?? are typically numbers used to force consistent patch ordering.
279# The arch field is used to apply patches only for the host architecture with
280# the special value of "all" means apply for everyone. Note that using values
281# other than "all" is highly discouraged -- you should apply patches all the
282# time and let architecture details be detected at configure/compile time.
155# 283#
156# For example: 284# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
285# for patches to apply.
157# 286#
158# 01_all_misc-fix.patch.bz2 287# Refer to the other EPATCH_xxx variables for more customization of behavior.
159# 02_sparc_another-fix.patch.bz2
160#
161# This ensures that there are a set order, and you can have ARCH
162# specific patches.
163#
164# If you however give an argument to epatch(), it will treat it as a
165# single patch that need to be applied if its a file. If on the other
166# hand its a directory, it will set EPATCH_SOURCE to this.
167#
168# <azarah@gentoo.org> (10 Nov 2002)
169#
170epatch() { 288epatch() {
171 local PIPE_CMD="" 289 _epatch_draw_line() {
172 local STDERR_TARGET="${T}/$$.out" 290 # create a line of same length as input string
173 local PATCH_TARGET="${T}/$$.patch" 291 [[ -z $1 ]] && set "$(printf "%65s" '')"
174 local PATCH_SUFFIX="" 292 echo "${1//?/=}"
175 local SINGLE_PATCH="no" 293 }
176 local x=""
177 294
178 if [ "$#" -gt 1 ] 295 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
179 then 296
297 # Let the rest of the code process one user arg at a time --
298 # each arg may expand into multiple patches, and each arg may
299 # need to start off with the default global EPATCH_xxx values
300 if [[ $# -gt 1 ]] ; then
180 local m="" 301 local m
181 for m in "$@" ; do 302 for m in "$@" ; do
182 epatch "${m}" 303 epatch "${m}"
183 done 304 done
184 return 0 305 return 0
185 fi 306 fi
186 307
187 if [ -n "$1" -a -f "$1" ] 308 local SINGLE_PATCH="no"
188 then 309 # no args means process ${EPATCH_SOURCE}
310 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
311
312 if [[ -f $1 ]] ; then
189 SINGLE_PATCH="yes" 313 SINGLE_PATCH="yes"
190 314 set -- "$1"
191 local EPATCH_SOURCE="$1" 315 # Use the suffix from the single patch (localize it); the code
316 # below will find the suffix for us
192 local EPATCH_SUFFIX="${1##*\.}" 317 local EPATCH_SUFFIX=$1
193 318
194 elif [ -n "$1" -a -d "$1" ] 319 elif [[ -d $1 ]] ; then
195 then 320 # Some people like to make dirs of patches w/out suffixes (vim)
196 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 321 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
197 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 322
323 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
324 # Re-use EPATCH_SOURCE as a search dir
325 epatch "${EPATCH_SOURCE}/$1"
326 return $?
327
328 else
329 # sanity check ... if it isn't a dir or file, wtf man ?
330 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
331 echo
332 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
333 eerror
334 eerror " ${EPATCH_SOURCE}"
335 eerror " ( ${EPATCH_SOURCE##*/} )"
336 echo
337 die "Cannot find \$EPATCH_SOURCE!"
338 fi
339
340 local PIPE_CMD
341 case ${EPATCH_SUFFIX##*\.} in
342 xz) PIPE_CMD="xz -dc" ;;
343 lzma) PIPE_CMD="lzma -dc" ;;
344 bz2) PIPE_CMD="bzip2 -dc" ;;
345 gz|Z|z) PIPE_CMD="gzip -dc" ;;
346 ZIP|zip) PIPE_CMD="unzip -p" ;;
347 *) ;;
348 esac
349
350 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
351
352 local x
353 for x in "$@" ; do
354 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
355 # didn't match anything, ignore continue on
356 [[ ! -f ${x} ]] && continue
357
358 local patchname=${x##*/}
359
360 # Apply single patches, or forced sets of patches, or
361 # patches with ARCH dependant names.
362 # ???_arch_foo.patch
363 # Else, skip this input altogether
364 local a=${patchname#*_} # strip the ???_
365 a=${a%%_*} # strip the _foo.patch
366 if ! [[ ${SINGLE_PATCH} == "yes" || \
367 ${EPATCH_FORCE} == "yes" || \
368 ${a} == all || \
369 ${a} == ${ARCH} ]]
198 then 370 then
199 local EPATCH_SOURCE="$1/*" 371 continue
372 fi
373
374 # Let people filter things dynamically
375 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
376 # let people use globs in the exclude
377 eshopts_push -o noglob
378
379 local ex
380 for ex in ${EPATCH_EXCLUDE} ; do
381 if [[ ${patchname} == ${ex} ]] ; then
382 eshopts_pop
383 continue 2
384 fi
385 done
386
387 eshopts_pop
388 fi
389
390 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
391 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
392 einfo "${EPATCH_SINGLE_MSG}"
393 else
394 einfo "Applying ${patchname} ..."
395 fi
200 else 396 else
201 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 397 einfo " ${patchname} ..."
202 fi 398 fi
203 else 399
204 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 400 # most of the time, there will only be one run per unique name,
205 then 401 # but if there are more, make sure we get unique log filenames
206 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 402 local STDERR_TARGET="${T}/${patchname}.out"
207 then 403 if [[ -e ${STDERR_TARGET} ]] ; then
208 EPATCH_SOURCE="$1" 404 STDERR_TARGET="${T}/${patchname}-$$.out"
405 fi
406
407 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
408
409 # Decompress the patch if need be
410 local count=0
411 local PATCH_TARGET
412 if [[ -n ${PIPE_CMD} ]] ; then
413 PATCH_TARGET="${T}/$$.patch"
414 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
415
416 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
417 echo
418 eerror "Could not extract patch!"
419 #die "Could not extract patch!"
420 count=5
421 break
209 fi 422 fi
423 else
424 PATCH_TARGET=${x}
425 fi
210 426
427 # Check for absolute paths in patches. If sandbox is disabled,
428 # people could (accidently) patch files in the root filesystem.
429 # Or trigger other unpleasantries #237667. So disallow -p0 on
430 # such patches.
431 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
432 if [[ -n ${abs_paths} ]] ; then
433 count=1
434 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
435 fi
436 # Similar reason, but with relative paths.
437 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
438 if [[ -n ${rel_paths} ]] ; then
439 eqawarn "QA Notice: Your patch uses relative paths '../'."
440 eqawarn " In the future this will cause a failure."
441 eqawarn "${rel_paths}"
442 fi
443
444 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
445 local patch_cmd
446 while [[ ${count} -lt 5 ]] ; do
447 patch_cmd="patch -p${count} ${EPATCH_OPTS}"
448
449 # Generate some useful debug info ...
450 (
451 _epatch_draw_line "***** ${patchname} *****"
211 echo 452 echo
212 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 453 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
454 echo
455 _epatch_draw_line "***** ${patchname} *****"
456 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
457 ret=$?
458 echo
459 echo "patch program exited with status ${ret}"
460 exit ${ret}
461 ) >> "${STDERR_TARGET}"
462
463 if [ $? -eq 0 ] ; then
464 (
465 _epatch_draw_line "***** ${patchname} *****"
466 echo
467 echo "ACTUALLY APPLYING ${patchname} ..."
468 echo
469 _epatch_draw_line "***** ${patchname} *****"
470 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
471 ret=$?
472 echo
473 echo "patch program exited with status ${ret}"
474 exit ${ret}
475 ) >> "${STDERR_TARGET}"
476
477 if [ $? -ne 0 ] ; then
478 echo
479 eerror "A dry-run of patch command succeeded, but actually"
480 eerror "applying the patch failed!"
481 #die "Real world sux compared to the dreamworld!"
482 count=5
483 fi
484 break
485 fi
486
487 : $(( count++ ))
488 done
489
490 # if we had to decompress the patch, delete the temp one
491 if [[ -n ${PIPE_CMD} ]] ; then
492 rm -f "${PATCH_TARGET}"
493 fi
494
495 if [[ ${count} -ge 5 ]] ; then
496 echo
497 eerror "Failed Patch: ${patchname} !"
498 eerror " ( ${PATCH_TARGET} )"
213 eerror 499 eerror
214 eerror " ${EPATCH_SOURCE}" 500 eerror "Include in your bugreport the contents of:"
215 eerror " ( ${EPATCH_SOURCE##*/} )" 501 eerror
502 eerror " ${STDERR_TARGET}"
216 echo 503 echo
217 die "Cannot find \$EPATCH_SOURCE!"
218 fi
219
220 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
221 fi
222
223 case ${EPATCH_SUFFIX##*\.} in
224 bz2)
225 PIPE_CMD="bzip2 -dc"
226 PATCH_SUFFIX="bz2"
227 ;;
228 gz|Z|z)
229 PIPE_CMD="gzip -dc"
230 PATCH_SUFFIX="gz"
231 ;;
232 ZIP|zip)
233 PIPE_CMD="unzip -p"
234 PATCH_SUFFIX="zip"
235 ;;
236 *)
237 PIPE_CMD="cat"
238 PATCH_SUFFIX="patch"
239 ;;
240 esac
241
242 if [ "${SINGLE_PATCH}" = "no" ]
243 then
244 einfo "${EPATCH_MULTI_MSG}"
245 fi
246 for x in ${EPATCH_SOURCE}
247 do
248 # New ARCH dependant patch naming scheme ...
249 #
250 # ???_arch_foo.patch
251 #
252 if [ -f ${x} ] && \
253 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
254 [ "${EPATCH_FORCE}" = "yes" ])
255 then
256 local count=0
257 local popts="${EPATCH_OPTS}"
258 local patchname=${x##*/}
259
260 if [ -n "${EPATCH_EXCLUDE}" ]
261 then
262 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
263 then
264 continue
265 fi
266 fi
267
268 if [ "${SINGLE_PATCH}" = "yes" ]
269 then
270 if [ -n "${EPATCH_SINGLE_MSG}" ]
271 then
272 einfo "${EPATCH_SINGLE_MSG}"
273 else
274 einfo "Applying ${patchname} ..."
275 fi
276 else
277 einfo " ${patchname} ..."
278 fi
279
280 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
281 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
282
283 # Allow for prefix to differ ... im lazy, so shoot me :/
284 while [ "${count}" -lt 5 ]
285 do
286 # Generate some useful debug info ...
287 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
288 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
289
290 if [ "${PATCH_SUFFIX}" != "patch" ]
291 then
292 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
293 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
294 else
295 PATCH_TARGET="${x}"
296 fi
297
298 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
299 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
300
301 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
302 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
303
304 if [ "${PATCH_SUFFIX}" != "patch" ]
305 then
306 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
307 then
308 echo
309 eerror "Could not extract patch!"
310 #die "Could not extract patch!"
311 count=5
312 break
313 fi
314 fi
315
316 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
317 then
318 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
319 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
320 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
321 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
322 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
323
324 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
325
326 if [ "$?" -ne 0 ]
327 then
328 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
329 echo
330 eerror "A dry-run of patch command succeeded, but actually"
331 eerror "applying the patch failed!"
332 #die "Real world sux compared to the dreamworld!"
333 count=5
334 fi
335
336 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
337
338 break
339 fi
340
341 count=$((count + 1))
342 done
343
344 if [ "${PATCH_SUFFIX}" != "patch" ]
345 then
346 rm -f ${PATCH_TARGET}
347 fi
348
349 if [ "${count}" -eq 5 ]
350 then
351 echo
352 eerror "Failed Patch: ${patchname} !"
353 eerror " ( ${PATCH_TARGET} )"
354 eerror
355 eerror "Include in your bugreport the contents of:"
356 eerror
357 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
358 echo
359 die "Failed Patch: ${patchname}!" 504 die "Failed Patch: ${patchname}!"
360 fi 505 fi
361 506
362 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 507 # if everything worked, delete the full debug patch log
508 rm -f "${STDERR_TARGET}"
363 509
510 # then log away the exact stuff for people to review later
511 cat <<-EOF >> "${T}/epatch.log"
512 PATCH: ${x}
513 CMD: ${patch_cmd}
514 PWD: ${PWD}
515
516 EOF
364 eend 0 517 eend 0
365 fi
366 done 518 done
367 if [ "${SINGLE_PATCH}" = "no" ] 519
368 then 520 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
369 einfo "Done with patching" 521 : # everything worked
522}
523
524# @FUNCTION: epatch_user
525# @USAGE:
526# @DESCRIPTION:
527# Applies user-provided patches to the source tree. The patches are
528# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
529# of these three directories to exist will be the one to use, ignoring
530# any more general directories which might exist as well.
531#
532# User patches are intended for quick testing of patches without ebuild
533# modifications, as well as for permanent customizations a user might
534# desire. Obviously, there can be no official support for arbitrarily
535# patched ebuilds. So whenever a build log in a bug report mentions that
536# user patches were applied, the user should be asked to reproduce the
537# problem without these.
538#
539# Not all ebuilds do call this function, so placing patches in the
540# stated directory might or might not work, depending on the package and
541# the eclasses it inherits and uses. It is safe to call the function
542# repeatedly, so it is always possible to add a call at the ebuild
543# level. The first call is the time when the patches will be
544# applied.
545#
546# Ideally, this function should be called after gentoo-specific patches
547# have been applied, so that their code can be modified as well, but
548# before calls to e.g. eautoreconf, as the user patches might affect
549# autotool input files as well.
550epatch_user() {
551 [[ $# -ne 0 ]] && die "epatch_user takes no options"
552
553 # Allow multiple calls to this function; ignore all but the first
554 local applied="${T}/epatch_user.log"
555 [[ -e ${applied} ]] && return 2
556
557 # don't clobber any EPATCH vars that the parent might want
558 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
559 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
560 EPATCH_SOURCE=${base}/${CTARGET}/${check}
561 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
562 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
563 if [[ -d ${EPATCH_SOURCE} ]] ; then
564 EPATCH_SOURCE=${EPATCH_SOURCE} \
565 EPATCH_SUFFIX="patch" \
566 EPATCH_FORCE="yes" \
567 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
568 epatch
569 echo "${EPATCH_SOURCE}" > "${applied}"
570 return 0
370 fi 571 fi
572 done
573 echo "none" > "${applied}"
574 return 1
371} 575}
372 576
577# @FUNCTION: emktemp
578# @USAGE: [temp dir]
579# @DESCRIPTION:
373# Cheap replacement for when debianutils (and thus mktemp) 580# Cheap replacement for when debianutils (and thus mktemp)
374# does not exist on the users system 581# does not exist on the users system.
375# vapier@gentoo.org
376#
377# Takes just 1 optional parameter (the directory to create tmpfile in)
378emktemp() { 582emktemp() {
379 local exe="touch" 583 local exe="touch"
380 [ "$1" == "-d" ] && exe="mkdir" && shift 584 [[ $1 == -d ]] && exe="mkdir" && shift
381 local topdir="$1" 585 local topdir=$1
382 586
383 if [ -z "${topdir}" ] 587 if [[ -z ${topdir} ]] ; then
384 then
385 [ -z "${T}" ] \ 588 [[ -z ${T} ]] \
386 && topdir="/tmp" \ 589 && topdir="/tmp" \
387 || topdir="${T}" 590 || topdir=${T}
388 fi 591 fi
389 592
390 if [ -z "$(type -p mktemp)" ] 593 if ! type -P mktemp > /dev/null ; then
391 then 594 # system lacks `mktemp` so we have to fake it
392 local tmp=/ 595 local tmp=/
393 while [ -e "${tmp}" ] ; do 596 while [[ -e ${tmp} ]] ; do
394 tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}" 597 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
395 done 598 done
396 ${exe} "${tmp}" 599 ${exe} "${tmp}" || ${exe} -p "${tmp}"
397 echo "${tmp}" 600 echo "${tmp}"
398 else 601 else
399 [ "${exe}" == "touch" ] \ 602 # the args here will give slightly wierd names on BSD,
400 && exe="-p" \ 603 # but should produce a usable file on all userlands
401 || exe="-d" 604 if [[ ${exe} == "touch" ]] ; then
402 mktemp ${exe} "${topdir}" 605 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
403 fi
404}
405
406# Small wrapper for getent (Linux), nidump (Mac OS X),
407# and pw (FreeBSD) used in enewuser()/enewgroup()
408# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
409# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
410#
411# egetent(database, key)
412egetent() {
413 if [[ "${USERLAND}" == "Darwin" ]] ; then
414 case "$2" in
415 *[!0-9]*) # Non numeric
416 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
417 ;;
418 *) # Numeric
419 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
420 ;;
421 esac
422 elif [[ "${USERLAND}" == "BSD" ]] ; then
423 local action
424 if [ "$1" == "passwd" ]
425 then
426 action="user"
427 else 606 else
428 action="group" 607 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
429 fi
430 pw show "${action}" "$2" -q
431 else
432 which nscd >& /dev/null && nscd -i "$1"
433 getent "$1" "$2"
434 fi
435}
436
437# Simplify/standardize adding users to the system
438# vapier@gentoo.org
439#
440# enewuser(username, uid, shell, homedir, groups, extra options)
441#
442# Default values if you do not specify any:
443# username: REQUIRED !
444# uid: next available (see useradd(8))
445# note: pass -1 to get default behavior
446# shell: /bin/false
447# homedir: /dev/null
448# groups: none
449# extra: comment of 'added by portage for ${PN}'
450enewuser() {
451 # get the username
452 local euser=$1; shift
453 if [[ -z ${euser} ]] ; then
454 eerror "No username specified !"
455 die "Cannot call enewuser without a username"
456 fi
457
458 # lets see if the username already exists
459 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
460 return 0
461 fi
462 einfo "Adding user '${euser}' to your system ..."
463
464 # options to pass to useradd
465 local opts=
466
467 # handle uid
468 local euid=$1; shift
469 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
470 if [[ ${euid} -gt 0 ]] ; then
471 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
472 euid="next"
473 fi 608 fi
474 else
475 eerror "Userid given but is not greater than 0 !"
476 die "${euid} is not a valid UID"
477 fi 609 fi
478 else
479 euid="next"
480 fi
481 if [[ ${euid} == "next" ]] ; then
482 local pwrange
483 if [[ ${USERLAND} == "BSD" ]] ; then
484 pwrange=$(jot 898 101)
485 else
486 pwrange=$(seq 101 999)
487 fi
488 for euid in ${pwrange} ; do
489 [[ -z $(egetent passwd ${euid}) ]] && break
490 done
491 fi
492 opts="${opts} -u ${euid}"
493 einfo " - Userid: ${euid}"
494
495 # handle shell
496 local eshell=$1; shift
497 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
498 if [[ ! -e ${eshell} ]] ; then
499 eerror "A shell was specified but it does not exist !"
500 die "${eshell} does not exist"
501 fi
502 else
503 case ${USERLAND} in
504 Darwin) eshell="/usr/bin/false";;
505 BSD) eshell="/usr/sbin/nologin";;
506 *) eshell="/bin/false";;
507 esac
508 fi
509 einfo " - Shell: ${eshell}"
510 opts="${opts} -s ${eshell}"
511
512 # handle homedir
513 local ehome=$1; shift
514 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
515 ehome="/dev/null"
516 fi
517 einfo " - Home: ${ehome}"
518 opts="${opts} -d ${ehome}"
519
520 # handle groups
521 local egroups=$1; shift
522 if [[ ! -z ${egroups} ]] ; then
523 local oldifs=${IFS}
524 local defgroup="" exgroups=""
525
526 export IFS=","
527 for g in ${egroups} ; do
528 export IFS=${oldifs}
529 if [[ -z $(egetent group "${g}") ]] ; then
530 eerror "You must add group ${g} to the system first"
531 die "${g} is not a valid GID"
532 fi
533 if [[ -z ${defgroup} ]] ; then
534 defgroup=${g}
535 else
536 exgroups="${exgroups},${g}"
537 fi
538 export IFS=","
539 done
540 export IFS=${oldifs}
541
542 opts="${opts} -g ${defgroup}"
543 if [[ ! -z ${exgroups} ]] ; then
544 opts="${opts} -G ${exgroups:1}"
545 fi
546 else
547 egroups="(none)"
548 fi
549 einfo " - Groups: ${egroups}"
550
551 # handle extra and add the user
552 local oldsandbox=${SANDBOX_ON}
553 export SANDBOX_ON="0"
554 case ${USERLAND} in
555 Darwin)
556 ### Make the user
557 if [[ -z $@ ]] ; then
558 dscl . create /users/${euser} uid ${euid}
559 dscl . create /users/${euser} shell ${eshell}
560 dscl . create /users/${euser} home ${ehome}
561 dscl . create /users/${euser} realname "added by portage for ${PN}"
562 ### Add the user to the groups specified
563 local oldifs=${IFS}
564 export IFS=","
565 for g in ${egroups} ; do
566 dscl . merge /groups/${g} users ${euser}
567 done
568 export IFS=${oldifs}
569 else
570 einfo "Extra options are not supported on Darwin yet"
571 einfo "Please report the ebuild along with the info below"
572 einfo "eextra: $@"
573 die "Required function missing"
574 fi
575 ;;
576 BSD)
577 if [[ -z $@ ]] ; then
578 pw useradd ${euser} ${opts} \
579 -c "added by portage for ${PN}" \
580 die "enewuser failed"
581 else
582 einfo " - Extra: $@"
583 pw useradd ${euser} ${opts} \
584 "$@" || die "enewuser failed"
585 fi
586 ;;
587 *)
588 if [[ -z $@ ]] ; then
589 useradd ${opts} ${euser} \
590 -c "added by portage for ${PN}" \
591 || die "enewuser failed"
592 else
593 einfo " - Extra: $@"
594 useradd ${opts} ${euser} "$@" \
595 || die "enewuser failed"
596 fi
597 ;;
598 esac
599 export SANDBOX_ON=${oldsandbox}
600
601 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
602 then
603 einfo " - Creating ${ehome} in ${D}"
604 dodir ${ehome}
605 fowners ${euser} ${ehome}
606 fperms 755 ${ehome}
607 fi
608} 610}
609 611
610# Simplify/standardize adding groups to the system 612# @FUNCTION: edos2unix
611# vapier@gentoo.org 613# @USAGE: <file> [more files ...]
612# 614# @DESCRIPTION:
613# enewgroup(group, gid) 615# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
614# 616# to remove all of these text utilities from DEPEND variables because this
615# Default values if you do not specify any: 617# is a script based solution. Just give it a list of files to convert and
616# groupname: REQUIRED ! 618# they will all be changed from the DOS CRLF format to the UNIX LF format.
617# gid: next available (see groupadd(8))
618# extra: none
619enewgroup() {
620 # get the group
621 local egroup="$1"; shift
622 if [ -z "${egroup}" ]
623 then
624 eerror "No group specified !"
625 die "Cannot call enewgroup without a group"
626 fi
627
628 # see if group already exists
629 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
630 then
631 return 0
632 fi
633 einfo "Adding group '${egroup}' to your system ..."
634
635 # options to pass to useradd
636 local opts=
637
638 # handle gid
639 local egid="$1"; shift
640 if [ ! -z "${egid}" ]
641 then
642 if [ "${egid}" -gt 0 ]
643 then
644 if [ -z "`egetent group ${egid}`" ]
645 then
646 if [[ "${USERLAND}" == "Darwin" ]]; then
647 opts="${opts} ${egid}"
648 else
649 opts="${opts} -g ${egid}"
650 fi
651 else
652 egid="next available; requested gid taken"
653 fi
654 else
655 eerror "Groupid given but is not greater than 0 !"
656 die "${egid} is not a valid GID"
657 fi
658 else
659 egid="next available"
660 fi
661 einfo " - Groupid: ${egid}"
662
663 # handle extra
664 local eextra="$@"
665 opts="${opts} ${eextra}"
666
667 # add the group
668 local oldsandbox="${SANDBOX_ON}"
669 export SANDBOX_ON="0"
670 if [[ "${USERLAND}" == "Darwin" ]]; then
671 if [ ! -z "${eextra}" ];
672 then
673 einfo "Extra options are not supported on Darwin/OS X yet"
674 einfo "Please report the ebuild along with the info below"
675 einfo "eextra: ${eextra}"
676 die "Required function missing"
677 fi
678
679 # If we need the next available
680 case ${egid} in
681 *[!0-9]*) # Non numeric
682 for egid in `jot 898 101`; do
683 [ -z "`egetent group ${egid}`" ] && break
684 done
685 esac
686 dscl . create /groups/${egroup} gid ${egid}
687 dscl . create /groups/${egroup} passwd '*'
688 elif [[ "${USERLAND}" == "BSD" ]] ; then
689 case ${egid} in
690 *[!0-9]*) # Non numeric
691 for egid in `jot 898 101`; do
692 [ -z "`egetent group ${egid}`" ] && break
693 done
694 esac
695 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
696 else
697 groupadd ${opts} ${egroup} || die "enewgroup failed"
698 fi
699 export SANDBOX_ON="${oldsandbox}"
700}
701
702# Simple script to replace 'dos2unix' binaries
703# vapier@gentoo.org
704#
705# edos2unix(file, <more files> ...)
706edos2unix() { 619edos2unix() {
707 for f in "$@" 620 [[ $# -eq 0 ]] && return 0
708 do 621 sed -i 's/\r$//' -- "$@" || die
709 cp "${f}" ${T}/edos2unix
710 sed 's/\r$//' ${T}/edos2unix > "${f}"
711 done
712} 622}
713 623
714 624# @FUNCTION: make_desktop_entry
715############################################################## 625# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
716# START: Handle .desktop files and menu entries # 626# @DESCRIPTION:
717# maybe this should be separated into a new eclass some time #
718# lanius@gentoo.org #
719##############################################################
720
721# Make a desktop file ! 627# Make a .desktop file.
722# Great for making those icons in kde/gnome startmenu !
723# Amaze your friends ! Get the women ! Join today !
724# 628#
725# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 629# @CODE
726#
727# binary: what binary does the app run with ? 630# binary: what command does the app run with ?
728# name: the name that will show up in the menu 631# name: the name that will show up in the menu
729# icon: give your little like a pretty little icon ... 632# icon: give your little like a pretty little icon ...
730# this can be relative (to /usr/share/pixmaps) or 633# this can be relative (to /usr/share/pixmaps) or
731# a full path to an icon 634# a full path to an icon
732# type: what kind of application is this ? for categories: 635# type: what kind of application is this?
733# http://www.freedesktop.org/Standards/desktop-entry-spec 636# for categories:
734# path: if your app needs to startup in a specific dir 637# http://standards.freedesktop.org/menu-spec/latest/apa.html
638# if unset, function tries to guess from package's category
639# fields: extra fields to append to the desktop file; a printf string
640# @CODE
735make_desktop_entry() { 641make_desktop_entry() {
736 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 642 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
737 643
738 local exec=${1} 644 local exec=${1}
739 local name=${2:-${PN}} 645 local name=${2:-${PN}}
740 local icon=${3:-${PN}.png} 646 local icon=${3:-${PN}}
741 local type=${4} 647 local type=${4}
742 local path=${5} 648 local fields=${5}
743 649
744 if [[ -z ${type} ]] ; then 650 if [[ -z ${type} ]] ; then
745 local catmaj=${CATEGORY%%-*} 651 local catmaj=${CATEGORY%%-*}
746 local catmin=${CATEGORY##*-} 652 local catmin=${CATEGORY##*-}
747 case ${catmaj} in 653 case ${catmaj} in
748 app) 654 app)
749 case ${catmin} in 655 case ${catmin} in
656 accessibility) type="Utility;Accessibility";;
750 admin) type=System;; 657 admin) type=System;;
658 antivirus) type=System;;
659 arch) type="Utility;Archiving";;
660 backup) type="Utility;Archiving";;
751 cdr) type=DiscBurning;; 661 cdr) type="AudioVideo;DiscBurning";;
752 dicts) type=Dictionary;; 662 dicts) type="Office;Dictionary";;
663 doc) type=Documentation;;
753 editors) type=TextEditor;; 664 editors) type="Utility;TextEditor";;
754 emacs) type=TextEditor;; 665 emacs) type="Development;TextEditor";;
755 emulation) type=Emulator;; 666 emulation) type="System;Emulator";;
756 laptop) type=HardwareSettings;; 667 laptop) type="Settings;HardwareSettings";;
757 office) type=Office;; 668 office) type=Office;;
669 pda) type="Office;PDA";;
758 vim) type=TextEditor;; 670 vim) type="Development;TextEditor";;
759 xemacs) type=TextEditor;; 671 xemacs) type="Development;TextEditor";;
760 *) type=;;
761 esac 672 esac
762 ;; 673 ;;
763 674
764 dev) 675 dev)
765 type="Development" 676 type="Development"
766 ;; 677 ;;
767 678
768 games) 679 games)
769 case ${catmin} in 680 case ${catmin} in
770 action) type=ActionGame;; 681 action|fps) type=ActionGame;;
771 arcade) type=ArcadeGame;; 682 arcade) type=ArcadeGame;;
772 board) type=BoardGame;; 683 board) type=BoardGame;;
773 kid) type=KidsGame;;
774 emulation) type=Emulator;; 684 emulation) type=Emulator;;
685 kids) type=KidsGame;;
775 puzzle) type=LogicGame;; 686 puzzle) type=LogicGame;;
687 roguelike) type=RolePlaying;;
776 rpg) type=RolePlaying;; 688 rpg) type=RolePlaying;;
777 roguelike) type=RolePlaying;;
778 simulation) type=Simulation;; 689 simulation) type=Simulation;;
779 sports) type=SportsGame;; 690 sports) type=SportsGame;;
780 strategy) type=StrategyGame;; 691 strategy) type=StrategyGame;;
781 *) type=;;
782 esac 692 esac
783 type="Game;${type}" 693 type="Game;${type}"
784 ;; 694 ;;
785 695
696 gnome)
697 type="Gnome;GTK"
698 ;;
699
700 kde)
701 type="KDE;Qt"
702 ;;
703
786 mail) 704 mail)
787 type="Network;Email" 705 type="Network;Email"
788 ;; 706 ;;
789 707
790 media) 708 media)
791 case ${catmin} in 709 case ${catmin} in
710 gfx)
792 gfx) type=Graphics;; 711 type=Graphics
712 ;;
713 *)
714 case ${catmin} in
793 radio) type=Tuner;; 715 radio) type=Tuner;;
794 sound) type=Audio;; 716 sound) type=Audio;;
795 tv) type=TV;; 717 tv) type=TV;;
796 video) type=Video;; 718 video) type=Video;;
797 *) type=;; 719 esac
720 type="AudioVideo;${type}"
721 ;;
798 esac 722 esac
799 type="AudioVideo;${type}"
800 ;; 723 ;;
801 724
802 net) 725 net)
803 case ${catmin} in 726 case ${catmin} in
804 dialup) type=Dialup;; 727 dialup) type=Dialup;;
807 irc) type=IRCClient;; 730 irc) type=IRCClient;;
808 mail) type=Email;; 731 mail) type=Email;;
809 news) type=News;; 732 news) type=News;;
810 nntp) type=News;; 733 nntp) type=News;;
811 p2p) type=FileTransfer;; 734 p2p) type=FileTransfer;;
812 *) type=;; 735 voip) type=Telephony;;
813 esac 736 esac
814 type="Network;${type}" 737 type="Network;${type}"
815 ;; 738 ;;
816 739
817 sci) 740 sci)
818 case ${catmin} in 741 case ${catmin} in
819 astro*) type=Astronomoy;; 742 astro*) type=Astronomy;;
820 bio*) type=Biology;; 743 bio*) type=Biology;;
821 calc*) type=Calculator;; 744 calc*) type=Calculator;;
822 chem*) type=Chemistry;; 745 chem*) type=Chemistry;;
746 elec*) type=Electronics;;
823 geo*) type=Geology;; 747 geo*) type=Geology;;
824 math*) type=Math;; 748 math*) type=Math;;
825 *) type=;; 749 physics) type=Physics;;
750 visual*) type=DataVisualization;;
826 esac 751 esac
827 type="Science;${type}" 752 type="Education;Science;${type}"
753 ;;
754
755 sys)
756 type="System"
828 ;; 757 ;;
829 758
830 www) 759 www)
831 case ${catmin} in 760 case ${catmin} in
832 client) type=WebBrowser;; 761 client) type=WebBrowser;;
833 *) type=;;
834 esac 762 esac
835 type="Network" 763 type="Network;${type}"
836 ;; 764 ;;
837 765
838 *) 766 *)
839 type= 767 type=
840 ;; 768 ;;
843 if [ "${SLOT}" == "0" ] ; then 771 if [ "${SLOT}" == "0" ] ; then
844 local desktop_name="${PN}" 772 local desktop_name="${PN}"
845 else 773 else
846 local desktop_name="${PN}-${SLOT}" 774 local desktop_name="${PN}-${SLOT}"
847 fi 775 fi
776 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
848 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 777 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
849 778
779 # Don't append another ";" when a valid category value is provided.
780 type=${type%;}${type:+;}
781
782 eshopts_push -s extglob
783 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
784 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
785 ewarn "allowed in .desktop files if the value is not an absolute path."
786 icon=${icon%.@(xpm|png|svg)}
787 fi
788 eshopts_pop
789
790 cat <<-EOF > "${desktop}"
850echo "[Desktop Entry] 791 [Desktop Entry]
851Encoding=UTF-8
852Version=0.9.2
853Name=${name} 792 Name=${name}
854Type=Application 793 Type=Application
855Comment=${DESCRIPTION} 794 Comment=${DESCRIPTION}
856Exec=${exec} 795 Exec=${exec}
857Path=${path} 796 TryExec=${exec%% *}
858Icon=${icon} 797 Icon=${icon}
859Categories=Application;${type};" > "${desktop}" 798 Categories=${type}
799 EOF
860 800
801 if [[ ${fields:-=} != *=* ]] ; then
802 # 5th arg used to be value to Path=
803 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
804 fields="Path=${fields}"
805 fi
806 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
807
808 (
809 # wrap the env here so that the 'insinto' call
810 # doesn't corrupt the env of the caller
861 insinto /usr/share/applications 811 insinto /usr/share/applications
862 doins "${desktop}" 812 doins "${desktop}"
863 813 ) || die "installing desktop file failed"
864 return 0
865} 814}
866 815
867# Make a GDM/KDM Session file 816# @FUNCTION: validate_desktop_entries
868# 817# @USAGE: [directories]
869# make_desktop_entry(<title>, <command>) 818# @MAINTAINER:
870# title: File to execute to start the Window Manager 819# Carsten Lohrke <carlo@gentoo.org>
871# command: Name of the Window Manager 820# @DESCRIPTION:
821# Validate desktop entries using desktop-file-utils
822validate_desktop_entries() {
823 if [[ -x /usr/bin/desktop-file-validate ]] ; then
824 einfo "Checking desktop entry validity"
825 local directories=""
826 for d in /usr/share/applications $@ ; do
827 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
828 done
829 if [[ -n ${directories} ]] ; then
830 for FILE in $(find ${directories} -name "*\.desktop" \
831 -not -path '*.hidden*' | sort -u 2>/dev/null)
832 do
833 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
834 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
835 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
836 done
837 fi
838 echo ""
839 else
840 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
841 fi
842}
872 843
844# @FUNCTION: make_session_desktop
845# @USAGE: <title> <command> [command args...]
846# @DESCRIPTION:
847# Make a GDM/KDM Session file. The title is the file to execute to start the
848# Window Manager. The command is the name of the Window Manager.
849#
850# You can set the name of the file via the ${wm} variable.
873make_session_desktop() { 851make_session_desktop() {
874 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 852 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
875 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 853 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
876 854
877 local title=$1 855 local title=$1
878 local command=$2 856 local command=$2
879 local desktop=${T}/${wm}.desktop 857 local desktop=${T}/${wm:-${PN}}.desktop
858 shift 2
880 859
860 cat <<-EOF > "${desktop}"
881echo "[Desktop Entry] 861 [Desktop Entry]
882Encoding=UTF-8
883Name=${title} 862 Name=${title}
884Comment=This session logs you into ${title} 863 Comment=This session logs you into ${title}
885Exec=${command} 864 Exec=${command} $*
886TryExec=${command} 865 TryExec=${command}
887Type=Application" > "${desktop}" 866 Type=XSession
867 EOF
888 868
869 (
870 # wrap the env here so that the 'insinto' call
871 # doesn't corrupt the env of the caller
889 insinto /usr/share/xsessions 872 insinto /usr/share/xsessions
890 doins "${desktop}" 873 doins "${desktop}"
874 )
891} 875}
892 876
877# @FUNCTION: domenu
878# @USAGE: <menus>
879# @DESCRIPTION:
880# Install the list of .desktop menu files into the appropriate directory
881# (/usr/share/applications).
893domenu() { 882domenu() {
883 (
884 # wrap the env here so that the 'insinto' call
885 # doesn't corrupt the env of the caller
894 local i j 886 local i j ret=0
895 insinto /usr/share/applications 887 insinto /usr/share/applications
896 for i in "$@" ; do 888 for i in "$@" ; do
897 if [[ -f ${i} ]] ; then 889 if [[ -f ${i} ]] ; then
898 doins "${i}" 890 doins "${i}"
891 ((ret+=$?))
899 elif [[ -d ${i} ]] ; then 892 elif [[ -d ${i} ]] ; then
900 for j in "${i}"/*.desktop ; do 893 for j in "${i}"/*.desktop ; do
901 doins "${j}" 894 doins "${j}"
895 ((ret+=$?))
902 done 896 done
897 else
898 ((++ret))
903 fi 899 fi
904 done 900 done
901 exit ${ret}
902 )
905} 903}
904
905# @FUNCTION: newmenu
906# @USAGE: <menu> <newname>
907# @DESCRIPTION:
908# Like all other new* functions, install the specified menu as newname.
906newmenu() { 909newmenu() {
910 (
911 # wrap the env here so that the 'insinto' call
912 # doesn't corrupt the env of the caller
907 insinto /usr/share/applications 913 insinto /usr/share/applications
908 newins "$1" "$2" 914 newins "$@"
915 )
909} 916}
910 917
918# @FUNCTION: doicon
919# @USAGE: <list of icons>
920# @DESCRIPTION:
921# Install the list of icons into the icon directory (/usr/share/pixmaps).
922# This is useful in conjunction with creating desktop/menu files.
911doicon() { 923doicon() {
924 (
925 # wrap the env here so that the 'insinto' call
926 # doesn't corrupt the env of the caller
912 local i j 927 local i j ret
913 insinto /usr/share/pixmaps 928 insinto /usr/share/pixmaps
914 for i in "$@" ; do 929 for i in "$@" ; do
915 if [[ -f ${i} ]] ; then 930 if [[ -f ${i} ]] ; then
916 doins "${i}" 931 doins "${i}"
932 ((ret+=$?))
917 elif [[ -d ${i} ]] ; then 933 elif [[ -d ${i} ]] ; then
918 for j in "${i}"/*.png ; do 934 for j in "${i}"/*.png ; do
919 doins "${j}" 935 doins "${j}"
936 ((ret+=$?))
920 done 937 done
938 else
939 ((++ret))
921 fi 940 fi
922 done 941 done
942 exit ${ret}
943 )
923} 944}
945
946# @FUNCTION: newicon
947# @USAGE: <icon> <newname>
948# @DESCRIPTION:
949# Like all other new* functions, install the specified icon as newname.
924newicon() { 950newicon() {
951 (
952 # wrap the env here so that the 'insinto' call
953 # doesn't corrupt the env of the caller
925 insinto /usr/share/pixmaps 954 insinto /usr/share/pixmaps
926 newins "$1" "$2" 955 newins "$@"
956 )
927} 957}
928 958
929############################################################## 959# @FUNCTION: cdrom_get_cds
930# END: Handle .desktop files and menu entries # 960# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
931############################################################## 961# @DESCRIPTION:
932
933
934# for internal use only (unpack_pdv and unpack_makeself)
935find_unpackable_file() {
936 local src="$1"
937 if [ -z "${src}" ]
938 then
939 src="${DISTDIR}/${A}"
940 else
941 if [ -e "${DISTDIR}/${src}" ]
942 then
943 src="${DISTDIR}/${src}"
944 elif [ -e "${PWD}/${src}" ]
945 then
946 src="${PWD}/${src}"
947 elif [ -e "${src}" ]
948 then
949 src="${src}"
950 fi
951 fi
952 [ ! -e "${src}" ] && die "Could not find requested archive ${src}"
953 echo "${src}"
954}
955
956# Unpack those pesky pdv generated files ...
957# They're self-unpacking programs with the binary package stuffed in
958# the middle of the archive. Valve seems to use it a lot ... too bad
959# it seems to like to segfault a lot :(. So lets take it apart ourselves.
960#
961# Usage: unpack_pdv [file to unpack] [size of off_t]
962# - you have to specify the off_t size ... i have no idea how to extract that
963# information out of the binary executable myself. basically you pass in
964# the size of the off_t type (in bytes) on the machine that built the pdv
965# archive. one way to determine this is by running the following commands:
966# strings <pdv archive> | grep lseek
967# strace -elseek <pdv archive>
968# basically look for the first lseek command (we do the strings/grep because
969# sometimes the function call is _llseek or something) and steal the 2nd
970# parameter. here is an example:
971# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
972# lseek
973# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
974# lseek(3, -4, SEEK_END) = 2981250
975# thus we would pass in the value of '4' as the second parameter.
976unpack_pdv() {
977 local src="`find_unpackable_file $1`"
978 local sizeoff_t="$2"
979
980 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :("
981
982 local shrtsrc="`basename ${src}`"
983 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
984 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
985 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
986
987 # grab metadata for debug reasons
988 local metafile="$(emktemp)"
989 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
990
991 # rip out the final file name from the metadata
992 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
993 datafile="`basename ${datafile}`"
994
995 # now lets uncompress/untar the file if need be
996 local tmpfile="$(emktemp)"
997 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
998
999 local iscompressed="`file -b ${tmpfile}`"
1000 if [ "${iscompressed:0:8}" == "compress" ] ; then
1001 iscompressed=1
1002 mv ${tmpfile}{,.Z}
1003 gunzip ${tmpfile}
1004 else
1005 iscompressed=0
1006 fi
1007 local istar="`file -b ${tmpfile}`"
1008 if [ "${istar:0:9}" == "POSIX tar" ] ; then
1009 istar=1
1010 else
1011 istar=0
1012 fi
1013
1014 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1015 #dd if=${src} ibs=${metaskip} count=1 \
1016 # | dd ibs=${tailskip} skip=1 \
1017 # | gzip -dc \
1018 # > ${datafile}
1019 if [ ${iscompressed} -eq 1 ] ; then
1020 if [ ${istar} -eq 1 ] ; then
1021 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1022 | head -c $((${metaskip}-${tailskip})) \
1023 | tar -xzf -
1024 else
1025 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1026 | head -c $((${metaskip}-${tailskip})) \
1027 | gzip -dc \
1028 > ${datafile}
1029 fi
1030 else
1031 if [ ${istar} -eq 1 ] ; then
1032 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1033 | head -c $((${metaskip}-${tailskip})) \
1034 | tar --no-same-owner -xf -
1035 else
1036 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1037 | head -c $((${metaskip}-${tailskip})) \
1038 > ${datafile}
1039 fi
1040 fi
1041 true
1042 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1043 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1044}
1045
1046# Unpack those pesky makeself generated files ...
1047# They're shell scripts with the binary package tagged onto
1048# the end of the archive. Loki utilized the format as does
1049# many other game companies.
1050#
1051# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1052# - If the file is not specified then unpack will utilize ${A}.
1053# - If the offset is not specified then we will attempt to extract
1054# the proper offset from the script itself.
1055unpack_makeself() {
1056 local src="$(find_unpackable_file "$1")"
1057 local skip="$2"
1058 local exe="$3"
1059
1060 local shrtsrc="$(basename "${src}")"
1061 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1062 if [ -z "${skip}" ]
1063 then
1064 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`"
1065 local skip=0
1066 exe=tail
1067 case ${ver} in
1068 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1069 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1070 ;;
1071 2.0|2.0.1)
1072 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1073 ;;
1074 2.1.1)
1075 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1076 let skip="skip + 1"
1077 ;;
1078 2.1.2)
1079 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1080 let skip="skip + 1"
1081 ;;
1082 2.1.3)
1083 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1084 let skip="skip + 1"
1085 ;;
1086 2.1.4)
1087 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1088 skip=$(head -n ${skip} "${src}" | wc -c)
1089 exe="dd"
1090 ;;
1091 *)
1092 eerror "I'm sorry, but I was unable to support the Makeself file."
1093 eerror "The version I detected was '${ver}'."
1094 eerror "Please file a bug about the file ${shrtsrc} at"
1095 eerror "http://bugs.gentoo.org/ so that support can be added."
1096 die "makeself version '${ver}' not supported"
1097 ;;
1098 esac
1099 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1100 fi
1101 case ${exe} in
1102 tail) exe="tail -n +${skip} '${src}'";;
1103 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1104 *) die "makeself cant handle exe '${exe}'"
1105 esac
1106
1107 # lets grab the first few bytes of the file to figure out what kind of archive it is
1108 local tmpfile="$(emktemp)"
1109 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1110 local filetype="$(file -b "${tmpfile}")"
1111 case ${filetype} in
1112 *tar\ archive)
1113 eval ${exe} | tar --no-same-owner -xf -
1114 ;;
1115 bzip2*)
1116 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1117 ;;
1118 gzip*)
1119 eval ${exe} | tar --no-same-owner -xzf -
1120 ;;
1121 compress*)
1122 eval ${exe} | gunzip | tar --no-same-owner -xf -
1123 ;;
1124 *)
1125 eerror "Unknown filetype \"${filetype}\" ?"
1126 false
1127 ;;
1128 esac
1129 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1130}
1131
1132# Display a license for user to accept.
1133#
1134# Usage: check_license [license]
1135# - If the file is not specified then ${LICENSE} is used.
1136check_license() {
1137 local lic=$1
1138 if [ -z "${lic}" ] ; then
1139 lic="${PORTDIR}/licenses/${LICENSE}"
1140 else
1141 if [ -e "${PORTDIR}/licenses/${src}" ] ; then
1142 lic="${PORTDIR}/licenses/${src}"
1143 elif [ -e "${PWD}/${src}" ] ; then
1144 lic="${PWD}/${src}"
1145 elif [ -e "${src}" ] ; then
1146 lic="${src}"
1147 fi
1148 fi
1149 [ ! -f "${lic}" ] && die "Could not find requested license ${src}"
1150 local l="`basename ${lic}`"
1151
1152 # here is where we check for the licenses the user already
1153 # accepted ... if we don't find a match, we make the user accept
1154 local shopts=$-
1155 local alic
1156 set -o noglob #so that bash doesn't expand "*"
1157 for alic in ${ACCEPT_LICENSE} ; do
1158 if [[ ${alic} == * || ${alic} == ${l} ]]; then
1159 set +o noglob; set -${shopts} #reset old shell opts
1160 return 0
1161 fi
1162 done
1163 set +o noglob; set -$shopts #reset old shell opts
1164
1165 local licmsg="$(emktemp)"
1166 cat << EOF > ${licmsg}
1167**********************************************************
1168The following license outlines the terms of use of this
1169package. You MUST accept this license for installation to
1170continue. When you are done viewing, hit 'q'. If you
1171CTRL+C out of this, the install will not run!
1172**********************************************************
1173
1174EOF
1175 cat ${lic} >> ${licmsg}
1176 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1177 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1178 read alic
1179 case ${alic} in
1180 yes|Yes|y|Y)
1181 return 0
1182 ;;
1183 *)
1184 echo;echo;echo
1185 eerror "You MUST accept the license to continue! Exiting!"
1186 die "Failed to accept license"
1187 ;;
1188 esac
1189}
1190
1191# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 962# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1192# the whole 'non-interactive' policy, but damnit I want CD support ! 963# the whole 'non-interactive' policy, but damnit I want CD support !
1193# 964#
1194# with these cdrom functions we handle all the user interaction and 965# With these cdrom functions we handle all the user interaction and
1195# standardize everything. all you have to do is call cdrom_get_cds() 966# standardize everything. All you have to do is call cdrom_get_cds()
1196# and when the function returns, you can assume that the cd has been 967# and when the function returns, you can assume that the cd has been
1197# found at CDROM_ROOT. 968# found at CDROM_ROOT.
1198# 969#
970# The function will attempt to locate a cd based upon a file that is on
971# the cd. The more files you give this function, the more cds
972# the cdrom functions will handle.
973#
1199# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 974# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1200# etc... if you want to give the cds better names, then just export 975# etc... If you want to give the cds better names, then just export
1201# the CDROM_NAME_X variables before calling cdrom_get_cds(). 976# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
977# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
978# also use the CDROM_NAME_SET bash array.
1202# 979#
1203# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 980# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1204#
1205# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1206# - this will attempt to locate a cd based upon a file that is on
1207# the cd ... the more files you give this function, the more cds
1208# the cdrom functions will handle
1209cdrom_get_cds() { 981cdrom_get_cds() {
1210 # first we figure out how many cds we're dealing with by 982 # first we figure out how many cds we're dealing with by
1211 # the # of files they gave us 983 # the # of files they gave us
1212 local cdcnt=0 984 local cdcnt=0
1213 local f= 985 local f=
1214 for f in "$@" ; do 986 for f in "$@" ; do
1215 cdcnt=$((cdcnt + 1)) 987 ((++cdcnt))
1216 export CDROM_CHECK_${cdcnt}="$f" 988 export CDROM_CHECK_${cdcnt}="$f"
1217 done 989 done
1218 export CDROM_TOTAL_CDS=${cdcnt} 990 export CDROM_TOTAL_CDS=${cdcnt}
1219 export CDROM_CURRENT_CD=1 991 export CDROM_CURRENT_CD=1
1220 992
1221 # now we see if the user gave use CD_ROOT ... 993 # now we see if the user gave use CD_ROOT ...
1222 # if they did, let's just believe them that it's correct 994 # if they did, let's just believe them that it's correct
1223 if [[ ! -z ${CD_ROOT} ]] ; then
1224 export CDROM_ROOT=${CD_ROOT}
1225 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1226 return
1227 fi
1228 # do the same for CD_ROOT_X
1229 if [[ ! -z ${CD_ROOT_1} ]] ; then 995 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1230 local var= 996 local var=
1231 cdcnt=0 997 cdcnt=0
1232 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 998 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1233 cdcnt=$((cdcnt + 1)) 999 ((++cdcnt))
1234 var="CD_ROOT_${cdcnt}" 1000 var="CD_ROOT_${cdcnt}"
1001 [[ -z ${!var} ]] && var="CD_ROOT"
1235 if [[ -z ${!var} ]] ; then 1002 if [[ -z ${!var} ]] ; then
1236 eerror "You must either use just the CD_ROOT" 1003 eerror "You must either use just the CD_ROOT"
1237 eerror "or specify ALL the CD_ROOT_X variables." 1004 eerror "or specify ALL the CD_ROOT_X variables."
1238 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1005 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1239 die "could not locate CD_ROOT_${cdcnt}" 1006 die "could not locate CD_ROOT_${cdcnt}"
1240 fi 1007 fi
1241 export CDROM_ROOTS_${cdcnt}="${!var}"
1242 done 1008 done
1243 export CDROM_ROOT=${CDROM_ROOTS_1} 1009 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1244 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1010 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1011 export CDROM_SET=-1
1012 for f in ${CDROM_CHECK_1//:/ } ; do
1013 ((++CDROM_SET))
1014 [[ -e ${CDROM_ROOT}/${f} ]] && break
1015 done
1016 export CDROM_MATCH=${f}
1245 return 1017 return
1246 fi 1018 fi
1247 1019
1020 # User didn't help us out so lets make sure they know they can
1021 # simplify the whole process ...
1248 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1022 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1249 einfon "This ebuild will need the " 1023 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1250 if [[ -z ${CDROM_NAME} ]] ; then
1251 echo "cdrom for ${PN}."
1252 else
1253 echo "${CDROM_NAME}."
1254 fi
1255 echo 1024 echo
1256 einfo "If you do not have the CD, but have the data files" 1025 einfo "If you do not have the CD, but have the data files"
1257 einfo "mounted somewhere on your filesystem, just export" 1026 einfo "mounted somewhere on your filesystem, just export"
1258 einfo "the variable CD_ROOT so that it points to the" 1027 einfo "the variable CD_ROOT so that it points to the"
1259 einfo "directory containing the files." 1028 einfo "directory containing the files."
1260 echo 1029 echo
1261 einfo "For example:" 1030 einfo "For example:"
1262 einfo "export CD_ROOT=/mnt/cdrom" 1031 einfo "export CD_ROOT=/mnt/cdrom"
1263 echo 1032 echo
1264 else 1033 else
1034 if [[ -n ${CDROM_NAME_SET} ]] ; then
1035 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1036 cdcnt=0
1037 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1038 ((++cdcnt))
1039 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1040 done
1041 fi
1042
1265 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1043 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1266 cdcnt=0 1044 cdcnt=0
1267 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1045 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1268 cdcnt=$((cdcnt + 1)) 1046 ((++cdcnt))
1269 var="CDROM_NAME_${cdcnt}" 1047 var="CDROM_NAME_${cdcnt}"
1270 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}" 1048 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1271 done 1049 done
1272 echo 1050 echo
1273 einfo "If you do not have the CDs, but have the data files" 1051 einfo "If you do not have the CDs, but have the data files"
1274 einfo "mounted somewhere on your filesystem, just export" 1052 einfo "mounted somewhere on your filesystem, just export"
1275 einfo "the following variables so they point to the right place:" 1053 einfo "the following variables so they point to the right place:"
1276 einfon "" 1054 einfon ""
1277 cdcnt=0 1055 cdcnt=0
1278 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1056 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1279 cdcnt=$((cdcnt + 1)) 1057 ((++cdcnt))
1280 echo -n " CD_ROOT_${cdcnt}" 1058 echo -n " CD_ROOT_${cdcnt}"
1281 done 1059 done
1282 echo 1060 echo
1283 einfo "Or, if you have all the files in the same place, or" 1061 einfo "Or, if you have all the files in the same place, or"
1284 einfo "you only have one cdrom, you can export CD_ROOT" 1062 einfo "you only have one cdrom, you can export CD_ROOT"
1287 echo 1065 echo
1288 einfo "For example:" 1066 einfo "For example:"
1289 einfo "export CD_ROOT_1=/mnt/cdrom" 1067 einfo "export CD_ROOT_1=/mnt/cdrom"
1290 echo 1068 echo
1291 fi 1069 fi
1070
1071 export CDROM_SET=""
1292 export CDROM_CURRENT_CD=0 1072 export CDROM_CURRENT_CD=0
1293 cdrom_load_next_cd 1073 cdrom_load_next_cd
1294} 1074}
1295 1075
1296# this is only used when you need access to more than one cd. 1076# @FUNCTION: cdrom_load_next_cd
1297# when you have finished using the first cd, just call this function. 1077# @DESCRIPTION:
1298# when it returns, CDROM_ROOT will be pointing to the second cd. 1078# Some packages are so big they come on multiple CDs. When you're done reading
1299# remember, you can only go forward in the cd chain, you can't go back. 1079# files off a CD and want access to the next one, just call this function.
1080# Again, all the messy details of user interaction are taken care of for you.
1081# Once this returns, just read the variable CDROM_ROOT for the location of the
1082# mounted CD. Note that you can only go forward in the CD list, so make sure
1083# you only call this function when you're done using the current CD.
1300cdrom_load_next_cd() { 1084cdrom_load_next_cd() {
1301 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1302 local var= 1085 local var
1303 1086 ((++CDROM_CURRENT_CD))
1304 if [[ ! -z ${CD_ROOT} ]] ; then
1305 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1306 return
1307 fi
1308 1087
1309 unset CDROM_ROOT 1088 unset CDROM_ROOT
1310 var=CDROM_ROOTS_${CDROM_CURRENT_CD} 1089 var=CD_ROOT_${CDROM_CURRENT_CD}
1090 [[ -z ${!var} ]] && var="CD_ROOT"
1311 if [[ -z ${!var} ]] ; then 1091 if [[ -z ${!var} ]] ; then
1312 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1092 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1313 cdrom_locate_file_on_cd ${!var} 1093 _cdrom_locate_file_on_cd ${!var}
1314 else 1094 else
1315 export CDROM_ROOT=${!var} 1095 export CDROM_ROOT=${!var}
1316 fi 1096 fi
1317 1097
1318 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1098 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1323# all it does is try to locate a give file on a cd ... if the cd isn't 1103# all it does is try to locate a give file on a cd ... if the cd isn't
1324# found, then a message asking for the user to insert the cdrom will be 1104# found, then a message asking for the user to insert the cdrom will be
1325# displayed and we'll hang out here until: 1105# displayed and we'll hang out here until:
1326# (1) the file is found on a mounted cdrom 1106# (1) the file is found on a mounted cdrom
1327# (2) the user hits CTRL+C 1107# (2) the user hits CTRL+C
1328cdrom_locate_file_on_cd() { 1108_cdrom_locate_file_on_cd() {
1109 local mline=""
1110 local showedmsg=0 showjolietmsg=0
1111
1329 while [[ -z ${CDROM_ROOT} ]] ; do 1112 while [[ -z ${CDROM_ROOT} ]] ; do
1330 local dir=$(dirname "$*") 1113 local i=0
1114 local -a cdset=(${*//:/ })
1115 if [[ -n ${CDROM_SET} ]] ; then
1116 cdset=(${cdset[${CDROM_SET}]})
1117 fi
1118
1119 while [[ -n ${cdset[${i}]} ]] ; do
1120 local dir=$(dirname ${cdset[${i}]})
1331 local file=$(basename "$*") 1121 local file=$(basename ${cdset[${i}]})
1332 local mline=""
1333 local showedmsg=0
1334 1122
1335 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do 1123 local point= node= fs= foo=
1124 while read point node fs foo ; do
1125 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1126 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1127 && continue
1128 point=${point//\040/ }
1336 [[ -d ${mline}/${dir} ]] || continue 1129 [[ ! -d ${point}/${dir} ]] && continue
1337 [[ ! -z $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] \ 1130 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1338 && export CDROM_ROOT=${mline} 1131 export CDROM_ROOT=${point}
1132 export CDROM_SET=${i}
1133 export CDROM_MATCH=${cdset[${i}]}
1134 return
1135 done <<< "$(get_mounts)"
1136
1137 ((++i))
1339 done 1138 done
1340 1139
1341 if [[ -z ${CDROM_ROOT} ]] ; then
1342 echo 1140 echo
1343 if [[ ${showedmsg} -eq 0 ]] ; then 1141 if [[ ${showedmsg} -eq 0 ]] ; then
1344 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1142 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1345 if [[ -z ${CDROM_NAME} ]] ; then 1143 if [[ -z ${CDROM_NAME} ]] ; then
1346 einfo "Please insert the cdrom for ${PN} now !" 1144 einfo "Please insert+mount the cdrom for ${PN} now !"
1347 else
1348 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1349 fi
1350 else 1145 else
1351 if [[ -z ${CDROM_NAME_1} ]] ; then
1352 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1353 else
1354 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1355 einfo "Please insert+mount the ${!var} cdrom now !" 1146 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1356 fi
1357 fi 1147 fi
1358 showedmsg=1 1148 else
1149 if [[ -z ${CDROM_NAME_1} ]] ; then
1150 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1151 else
1152 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1153 einfo "Please insert+mount the ${!var} cdrom now !"
1154 fi
1359 fi 1155 fi
1156 showedmsg=1
1157 fi
1360 einfo "Press return to scan for the cd again" 1158 einfo "Press return to scan for the cd again"
1361 einfo "or hit CTRL+C to abort the emerge." 1159 einfo "or hit CTRL+C to abort the emerge."
1362 echo 1160 echo
1161 if [[ ${showjolietmsg} -eq 0 ]] ; then
1162 showjolietmsg=1
1163 else
1363 einfo "If you are having trouble with the detection" 1164 ewarn "If you are having trouble with the detection"
1364 einfo "of your CD, it is possible that you do not have" 1165 ewarn "of your CD, it is possible that you do not have"
1365 einfo "Joliet support enabled in your kernel. Please" 1166 ewarn "Joliet support enabled in your kernel. Please"
1366 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1167 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1367 read 1168 ebeep 5
1368 fi 1169 fi
1170 read || die "something is screwed with your system"
1369 done 1171 done
1370} 1172}
1371 1173
1174# @FUNCTION: strip-linguas
1175# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1176# @DESCRIPTION:
1372# Make sure that LINGUAS only contains languages that 1177# Make sure that LINGUAS only contains languages that
1373# a package can support 1178# a package can support. The first form allows you to
1374# 1179# specify a list of LINGUAS. The -i builds a list of po
1375# usage: strip-linguas <allow LINGUAS> 1180# files found in all the directories and uses the
1376# strip-linguas -i <directories of .po files> 1181# intersection of the lists. The -u builds a list of po
1377# strip-linguas -u <directories of .po files> 1182# files found in all the directories and uses the union
1378# 1183# of the lists.
1379# The first form allows you to specify a list of LINGUAS.
1380# The -i builds a list of po files found in all the
1381# directories and uses the intersection of the lists.
1382# The -u builds a list of po files found in all the
1383# directories and uses the union of the lists.
1384strip-linguas() { 1184strip-linguas() {
1385 local ls newls 1185 local ls newls nols
1386 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1186 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1387 local op=$1; shift 1187 local op=$1; shift
1388 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1188 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1389 local d f 1189 local d f
1390 for d in "$@" ; do 1190 for d in "$@" ; do
1391 if [[ ${op} == "-u" ]] ; then 1191 if [[ ${op} == "-u" ]] ; then
1392 newls=${ls} 1192 newls=${ls}
1393 else 1193 else
1394 newls="" 1194 newls=""
1395 fi 1195 fi
1396 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1196 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1397 if [[ ${op} == "-i" ]] ; then 1197 if [[ ${op} == "-i" ]] ; then
1398 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}" 1198 has ${f} ${ls} && newls="${newls} ${f}"
1399 else 1199 else
1400 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}" 1200 has ${f} ${ls} || newls="${newls} ${f}"
1401 fi 1201 fi
1402 done 1202 done
1403 ls=${newls} 1203 ls=${newls}
1404 done 1204 done
1405 ls=${ls//.po}
1406 else 1205 else
1407 ls=$@ 1206 ls="$@"
1408 fi 1207 fi
1409 1208
1410 ls=" ${ls} " 1209 nols=""
1411 newls="" 1210 newls=""
1412 for f in ${LINGUAS} ; do 1211 for f in ${LINGUAS} ; do
1413 if [[ ${ls/ ${f} /} != ${ls} ]] ; then 1212 if has ${f} ${ls} ; then
1414 newls="${newls} ${f}" 1213 newls="${newls} ${f}"
1415 else 1214 else
1416 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1215 nols="${nols} ${f}"
1417 fi 1216 fi
1418 done 1217 done
1419 if [[ -z ${newls} ]] ; then 1218 [[ -n ${nols} ]] \
1420 export LINGUAS="" 1219 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1421 else
1422 export LINGUAS=${newls:1} 1220 export LINGUAS=${newls:1}
1423 fi
1424} 1221}
1425 1222
1426# moved from kernel.eclass since they are generally useful outside of 1223# @FUNCTION: preserve_old_lib
1427# kernel.eclass -iggy (20041002) 1224# @USAGE: <libs to preserve> [more libs]
1428 1225# @DESCRIPTION:
1429# the following functions are useful in kernel module ebuilds, etc.
1430# for an example see ivtv or drbd ebuilds
1431
1432# set's ARCH to match what the kernel expects
1433set_arch_to_kernel() {
1434 i=10
1435 while ((i--)) ; do
1436 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1437 done
1438 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1439 case ${ARCH} in
1440 x86) export ARCH="i386";;
1441 amd64) export ARCH="x86_64";;
1442 hppa) export ARCH="parisc";;
1443 mips) export ARCH="mips";;
1444 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1445 *) export ARCH="${ARCH}";;
1446 esac
1447}
1448
1449# set's ARCH back to what portage expects
1450set_arch_to_portage() {
1451 i=10
1452 while ((i--)) ; do
1453 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1454 done
1455 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1456}
1457
1458# Jeremy Huddleston <eradicator@gentoo.org>:
1459# preserve_old_lib /path/to/libblah.so.0
1460# preserve_old_lib_notify /path/to/libblah.so.0
1461#
1462# These functions are useful when a lib in your package changes --soname. Such 1226# These functions are useful when a lib in your package changes ABI SONAME.
1463# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1227# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1464# would break packages that link against it. Most people get around this 1228# would break packages that link against it. Most people get around this
1465# by using the portage SLOT mechanism, but that is not always a relevant 1229# by using the portage SLOT mechanism, but that is not always a relevant
1466# solution, so instead you can add the following to your ebuilds: 1230# solution, so instead you can call this from pkg_preinst. See also the
1467# 1231# preserve_old_lib_notify function.
1468# src_install() {
1469# ...
1470# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1471# ...
1472# }
1473#
1474# pkg_postinst() {
1475# ...
1476# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1477# ...
1478# }
1479
1480preserve_old_lib() { 1232preserve_old_lib() {
1481 LIB=$1 1233 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1234 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1235 die "Invalid preserve_old_lib() usage"
1236 fi
1237 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1482 1238
1483 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1239 # let portage worry about it
1484 SONAME=`basename ${LIB}` 1240 has preserve-libs ${FEATURES} && return 0
1485 DIRNAME=`dirname ${LIB}`
1486 1241
1487 dodir ${DIRNAME} 1242 local lib dir
1488 cp ${ROOT}${LIB} ${D}${DIRNAME} 1243 for lib in "$@" ; do
1244 [[ -e ${ROOT}/${lib} ]] || continue
1245 dir=${lib%/*}
1246 dodir ${dir} || die "dodir ${dir} failed"
1247 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1489 touch ${D}${LIB} 1248 touch "${D}"/${lib}
1490 fi 1249 done
1491} 1250}
1492 1251
1252# @FUNCTION: preserve_old_lib_notify
1253# @USAGE: <libs to notify> [more libs]
1254# @DESCRIPTION:
1255# Spit helpful messages about the libraries preserved by preserve_old_lib.
1493preserve_old_lib_notify() { 1256preserve_old_lib_notify() {
1494 LIB=$1 1257 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1258 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1259 die "Invalid preserve_old_lib_notify() usage"
1260 fi
1495 1261
1496 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1262 # let portage worry about it
1497 SONAME=`basename ${LIB}` 1263 has preserve-libs ${FEATURES} && return 0
1498 1264
1265 local lib notice=0
1266 for lib in "$@" ; do
1267 [[ -e ${ROOT}/${lib} ]] || continue
1268 if [[ ${notice} -eq 0 ]] ; then
1269 notice=1
1499 ewarn "An old version of an installed library was detected on your system." 1270 ewarn "Old versions of installed libraries were detected on your system."
1500 ewarn "In order to avoid breaking packages that link against it, this older version" 1271 ewarn "In order to avoid breaking packages that depend on these old libs,"
1501 ewarn "is not being removed. In order to make full use of this newer version," 1272 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1502 ewarn "you will need to execute the following command:" 1273 ewarn "in order to remove these old dependencies. If you do not have this"
1503 ewarn " revdep-rebuild --soname ${SONAME}" 1274 ewarn "helper program, simply emerge the 'gentoolkit' package."
1275 ewarn
1276 fi
1277 # temp hack for #348634 #357225
1278 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1279 ewarn " # revdep-rebuild --library '${lib}'"
1280 done
1281 if [[ ${notice} -eq 1 ]] ; then
1504 ewarn 1282 ewarn
1505 ewarn "After doing that, you can safely remove ${LIB}" 1283 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1506 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1284 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1285 for lib in "$@" ; do
1286 ewarn " # rm '${lib}'"
1287 done
1507 fi 1288 fi
1508} 1289}
1509 1290
1510# Hack for people to figure out if a package was built with 1291# @FUNCTION: built_with_use
1511# certain USE flags 1292# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1293# @DESCRIPTION:
1512# 1294#
1513# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1295# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1514# ex: built_with_use xchat gtk2
1515# 1296#
1516# Flags: -a all USE flags should be utilized 1297# A temporary hack until portage properly supports DEPENDing on USE
1517# -o at least one USE flag should be utilized 1298# flags being enabled in packages. This will check to see if the specified
1518# Note: the default flag is '-a' 1299# DEPEND atom was built with the specified list of USE flags. The
1300# --missing option controls the behavior if called on a package that does
1301# not actually support the defined USE flags (aka listed in IUSE).
1302# The default is to abort (call die). The -a and -o flags control
1303# the requirements of the USE flags. They correspond to "and" and "or"
1304# logic. So the -a flag means all listed USE flags must be enabled
1305# while the -o flag means at least one of the listed IUSE flags must be
1306# enabled. The --hidden option is really for internal use only as it
1307# means the USE flag we're checking is hidden expanded, so it won't be found
1308# in IUSE like normal USE flags.
1309#
1310# Remember that this function isn't terribly intelligent so order of optional
1311# flags matter.
1519built_with_use() { 1312built_with_use() {
1313 local hidden="no"
1314 if [[ $1 == "--hidden" ]] ; then
1315 hidden="yes"
1316 shift
1317 fi
1318
1319 local missing_action="die"
1320 if [[ $1 == "--missing" ]] ; then
1321 missing_action=$2
1322 shift ; shift
1323 case ${missing_action} in
1324 true|false|die) ;;
1325 *) die "unknown action '${missing_action}'";;
1326 esac
1327 fi
1328
1520 local opt=$1 1329 local opt=$1
1521 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1330 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1522 1331
1523 local PKG=$(best_version $1) 1332 local PKG=$(best_version $1)
1333 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1524 shift 1334 shift
1525 1335
1526 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1336 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1527 [[ ! -e ${USEFILE} ]] && return 1 1337 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1338
1339 # if the IUSE file doesn't exist, the read will error out, we need to handle
1340 # this gracefully
1341 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1342 case ${missing_action} in
1343 true) return 0;;
1344 false) return 1;;
1345 die) die "Unable to determine what USE flags $PKG was built with";;
1346 esac
1347 fi
1348
1349 if [[ ${hidden} == "no" ]] ; then
1350 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1351 # Don't check USE_EXPAND #147237
1352 local expand
1353 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1354 if [[ $1 == ${expand}_* ]] ; then
1355 expand=""
1356 break
1357 fi
1358 done
1359 if [[ -n ${expand} ]] ; then
1360 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1361 case ${missing_action} in
1362 true) return 0;;
1363 false) return 1;;
1364 die) die "$PKG does not actually support the $1 USE flag!";;
1365 esac
1366 fi
1367 fi
1368 fi
1528 1369
1529 local USE_BUILT=$(<${USEFILE}) 1370 local USE_BUILT=$(<${USEFILE})
1530 while [[ $# -gt 0 ]] ; do 1371 while [[ $# -gt 0 ]] ; do
1531 if [[ ${opt} = "-o" ]] ; then 1372 if [[ ${opt} = "-o" ]] ; then
1532 has $1 ${USE_BUILT} && return 0 1373 has $1 ${USE_BUILT} && return 0
1536 shift 1377 shift
1537 done 1378 done
1538 [[ ${opt} = "-a" ]] 1379 [[ ${opt} = "-a" ]]
1539} 1380}
1540 1381
1382# @FUNCTION: epunt_cxx
1383# @USAGE: [dir to scan]
1384# @DESCRIPTION:
1541# Many configure scripts wrongly bail when a C++ compiler 1385# Many configure scripts wrongly bail when a C++ compiler could not be
1542# could not be detected. #73450 1386# detected. If dir is not specified, then it defaults to ${S}.
1387#
1388# http://bugs.gentoo.org/73450
1543epunt_cxx() { 1389epunt_cxx() {
1544 local dir=$1 1390 local dir=$1
1545 [[ -z ${dir} ]] && dir=${S} 1391 [[ -z ${dir} ]] && dir=${S}
1546 ebegin "Removing useless C++ checks" 1392 ebegin "Removing useless C++ checks"
1547 local f 1393 local f
1548 for f in $(find ${dir} -name configure) ; do 1394 find "${dir}" -name configure | while read f ; do
1549 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1395 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1550 done 1396 done
1551 eend 0 1397 eend 0
1552} 1398}
1553 1399
1554# dopamd <file> [more files] 1400# @FUNCTION: make_wrapper
1555# 1401# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1556# Install pam auth config file in /etc/pam.d 1402# @DESCRIPTION:
1557dopamd() { 1403# Create a shell wrapper script named wrapper in installpath
1558 [[ -z $1 ]] && die "dopamd requires at least one argument" 1404# (defaults to the bindir) to execute target (default of wrapper) by
1559 1405# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1560 use pam || return 0 1406# libpaths followed by optionally changing directory to chdir.
1561
1562 INSDESTTREE=/etc/pam.d \
1563 doins "$@" || die "failed to install $@"
1564}
1565# newpamd <old name> <new name>
1566#
1567# Install pam file <old name> as <new name> in /etc/pam.d
1568newpamd() {
1569 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1570
1571 use pam || return 0
1572
1573 INSDESTTREE=/etc/pam.d \
1574 newins "$1" "$2" || die "failed to install $1 as $2"
1575}
1576
1577# make a wrapper script ...
1578# NOTE: this was originally games_make_wrapper, but I noticed other places where
1579# this could be used, so I have moved it here and made it not games-specific
1580# -- wolf31o2
1581# $1 == wrapper name
1582# $2 == binary to run
1583# $3 == directory to chdir before running binary
1584# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1585# $5 == path for wrapper
1586make_wrapper() { 1407make_wrapper() {
1587 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1408 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1588 local tmpwrapper=$(emktemp) 1409 local tmpwrapper=$(emktemp)
1410 # We don't want to quote ${bin} so that people can pass complex
1411 # things as $bin ... "./someprog --args"
1589 cat << EOF > "${tmpwrapper}" 1412 cat << EOF > "${tmpwrapper}"
1590#!/bin/sh 1413#!/bin/sh
1591cd "${chdir}" 1414cd "${chdir:-.}"
1415if [ -n "${libdir}" ] ; then
1416 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1592export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}" 1417 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1418 else
1419 export LD_LIBRARY_PATH="${libdir}"
1420 fi
1421fi
1593exec ${bin} "\$@" 1422exec ${bin} "\$@"
1594EOF 1423EOF
1595 chmod go+rx "${tmpwrapper}" 1424 chmod go+rx "${tmpwrapper}"
1596 if [ -n "${5}" ] 1425 if [[ -n ${path} ]] ; then
1597 then 1426 (
1598 exeinto ${5} 1427 exeinto "${path}"
1599 newexe "${tmpwrapper}" "${wrapper}" 1428 newexe "${tmpwrapper}" "${wrapper}"
1429 ) || die
1600 else 1430 else
1601 newbin "${tmpwrapper}" "${wrapper}" 1431 newbin "${tmpwrapper}" "${wrapper}" || die
1432 fi
1433}
1434
1435# @FUNCTION: path_exists
1436# @USAGE: [-a|-o] <paths>
1437# @DESCRIPTION:
1438# Check if the specified paths exist. Works for all types of paths
1439# (files/dirs/etc...). The -a and -o flags control the requirements
1440# of the paths. They correspond to "and" and "or" logic. So the -a
1441# flag means all the paths must exist while the -o flag means at least
1442# one of the paths must exist. The default behavior is "and". If no
1443# paths are specified, then the return value is "false".
1444path_exists() {
1445 local opt=$1
1446 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1447
1448 # no paths -> return false
1449 # same behavior as: [[ -e "" ]]
1450 [[ $# -eq 0 ]] && return 1
1451
1452 local p r=0
1453 for p in "$@" ; do
1454 [[ -e ${p} ]]
1455 : $(( r += $? ))
1456 done
1457
1458 case ${opt} in
1459 -a) return $(( r != 0 )) ;;
1460 -o) return $(( r == $# )) ;;
1461 esac
1462}
1463
1464# @FUNCTION: in_iuse
1465# @USAGE: <flag>
1466# @DESCRIPTION:
1467# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1468# as necessary.
1469#
1470# Note that this function should not be used in the global scope.
1471in_iuse() {
1472 debug-print-function ${FUNCNAME} "${@}"
1473 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1474
1475 local flag=${1}
1476 local liuse=( ${IUSE} )
1477
1478 has "${flag}" "${liuse[@]#[+-]}"
1479}
1480
1481# @FUNCTION: use_if_iuse
1482# @USAGE: <flag>
1483# @DESCRIPTION:
1484# Return true if the given flag is in USE and IUSE.
1485#
1486# Note that this function should not be used in the global scope.
1487use_if_iuse() {
1488 in_iuse $1 || return 1
1489 use $1
1490}
1491
1492# @FUNCTION: usex
1493# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1494# @DESCRIPTION:
1495# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1496# otherwise echo [false output][false suffix] (defaults to "no").
1497usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1498
1499check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1500
1602 fi 1501fi
1603}

Legend:
Removed from v.1.192  
changed lines
  Added in v.1.384

  ViewVC Help
Powered by ViewVC 1.1.20